//+------------------------------------------------------------------+
//|                                           MA Cross and Money.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int       maSlow=18;
extern int       maFast=5;
extern bool      ShowLines=true;
//---- buffers
double UpBuffer[];
double DownBuffer[];

double AvgVol = 61;
string Curr = "";
int TimeFrame = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,UpBuffer);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,DownBuffer);
   SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   static bool bFirst = true;
   
    int iBar,nCountedBars;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   int limit=Bars-counted_bars;
   
      
   
   Curr = Symbol();
   TimeFrame = Period(); //PERIOD_M15;
   
   if (bFirst)
   {
      bFirst = false;
      CalcAvgVol();
   }
   
   AvgVol = 61;
   
   for(iBar = 0; iBar <= limit; iBar++)
   {
   
      int counter=iBar;
      double Range=0;
      double AvgRange=0;
      
      for (counter=iBar ;counter<=iBar+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;

      UpBuffer[iBar+1] = 0; DownBuffer[iBar+1] = 0;
      int iCross = maCrossed(iBar+1);
      if (iCross != 0)
      {
         //if (MoneyEntered(iBar+1))
            if (iCross == 1)
            {
               if (NewBar() && (iBar < 3))
               {
                  Print("** Xross up");
                  PlaySound("alert.wav");
               }
               UpBuffer[iBar+1] = iLow(Curr, Period(), iBar+1) - 0.5 * Range;
            }
            else
            {
               if (NewBar() && (iBar < 3))
               {
                  Print("** Xross down");
                  PlaySound("alert.wav");
               }
               DownBuffer[iBar+1] = iHigh(Curr, Period(), iBar+1) + 0.5 * Range;
            }
      }
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

bool NewBar()
{
   int p = TimeFrame;
   static datetime dtCurrTime = 0;
   
   if (iTime(Curr, p, 0) != dtCurrTime)
   {
      dtCurrTime = iTime(Curr, p , 0);
      return(true);
   }
   return(false);
}


// Calculate the volume average
void CalcAvgVol()
{
   double sum = 0.0;
   for(int ii=1; ii<201; ii++)
   {
      sum += iVolume(Curr, TimeFrame, ii);
   }
   AvgVol = sum / 200;
  
  
  AvgVol = 61;
}


int maCrossed(int i)
{
      double maFastnow = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i);
      double maFastprevious = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double maFastafter = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i-1);

      double maSlownow = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i);
      double maSlowprevious = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double maSlowafter = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i-1);
      
      if ((maFastnow > maSlownow) && (maFastprevious < maSlowprevious)) {// && (maFastafter > maSlowafter)) {
         return(1);
      }
      else if ((maFastnow < maSlownow) && (maFastprevious > maSlowprevious)) { // && (maFastafter < maSlowafter)) {
         return(-1);
      }
 
      return(0);
}



